<?xml version="1.0" encoding="utf-8"?>
<xs:schema elementFormDefault="qualified" xmlns:xs="http://www.w3.org/2001/XMLSchema" targetNamespace="http://dnpb.sourceforge.net/schemas/prebuild-1.7.xsd" xmlns="http://dnpb.sourceforge.net/schemas/prebuild-1.7.xsd">
  <xs:annotation>
    <xs:documentation>
      Copyright (c) 2004-2007
      Matthew Holmes (calefaction at houston . rr . com),
      Dan Moorehead (dan05a at gmail . com),
      David Hudson (jendave at  yahoo dot com),
      C.J. Adams-Collier (cjac at colliertech dot com)

      .NET Prebuild is a cross-platform XML-driven pre-build tool which
      allows developers to easily generate project or make files for major
      IDE's and .NET development tools including: Visual Studio .NET 2002,
      2003, and 2005, SharpDevelop, MonoDevelop, NAnt, Xcode and the GNU Autotools.

      BSD License:

      Redistribution and use in source and binary forms, with or without modification, are permitted
      provided that the following conditions are met:

      * Redistributions of source code must retain the above copyright notice, this list of conditions
      and the following disclaimer.
      * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
      and the following disclaimer in the documentation and/or other materials provided with the
      distribution.
      * The name of the author may not be used to endorse or promote products derived from this software
      without specific prior written permission.

      THIS SOFTWARE IS PROVIDED BY THE AUTHOR 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
      BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
      ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
      EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
      OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
      OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
      IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    </xs:documentation>
  </xs:annotation>
  
  <xs:element name="Prebuild">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="Process" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="Solution" minOccurs="1" maxOccurs="unbounded" />
      </xs:sequence>
      <xs:attribute name="version" />
      <xs:attribute name="checkOsVars" />
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Process" type="xs:string" />

  <xs:element name="Solution">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="Configuration" minOccurs="1" maxOccurs="unbounded" />
        <xs:element ref="Process" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="Options" minOccurs="0" />
        <xs:element ref="Files" minOccurs="0" />
        <xs:element ref="Project" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="Cleanup" minOccurs="0" maxOccurs="1" />
        <xs:element ref="DatabaseProject" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="EmbeddedSolution" minOccurs="0" maxOccurs="unbounded" />
      </xs:sequence>
      <xs:attribute name="name" type="xs:string" use="required" />
      <xs:attribute name="activeConfig" type="xs:string" default="Debug" />
      <xs:attribute name="path" type="xs:string" default="" />
      <xs:attribute name="version" type="xs:string" default="1.0.0" />
    </xs:complexType>
  </xs:element>

  <xs:element name="EmbeddedSolution">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="Process" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="Files" minOccurs="0" />
        <xs:element ref="Project" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="DatabaseProject" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="EmbeddedSolution" minOccurs="0" maxOccurs="unbounded" />
      </xs:sequence>
      <xs:attribute name="name" type="xs:string" use="required" />
      <xs:attribute name="activeConfig" type="xs:string" default="Debug" />
      <xs:attribute name="path" type="xs:string" default="" />
      <xs:attribute name="version" type="xs:string" default="1.0.0" />
    </xs:complexType>
  </xs:element>
  
  <xs:element name="DatabaseProject">
    <xs:complexType>
      <xs:sequence>
        <xs:element name="Author" type="xs:string" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="DatabaseReference" minOccurs="0" maxOccurs="unbounded" />
      </xs:sequence>
      <xs:attribute name="name" type="xs:string" use="required" />
      <xs:attribute name="path" type="xs:string" />
    </xs:complexType>
  </xs:element>

  <xs:element name="DatabaseReference">
    <xs:complexType>
      <xs:attribute name="name" type="xs:string" use="required" />
      <xs:attribute name="providerId" type="xs:string" />
      <xs:attribute name="providerName" type="xs:string" />
      <xs:attribute name="connectionString" type="xs:string" use="required" />
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Project">
    <xs:complexType>
      <xs:sequence>
        <xs:element name="Author" type="xs:string" minOccurs="0" maxOccurs="unbounded" />
        <xs:element name="Description" type="xs:string" minOccurs="0" maxOccurs="1" />
        <xs:element ref="Configuration" minOccurs="1" maxOccurs="unbounded" />
        <xs:element name="ReferencePath" type="xs:string" minOccurs="0" maxOccurs="unbounded" />
        <xs:element name="Reference" minOccurs="0" maxOccurs="unbounded">
          <xs:complexType>
            <xs:attribute name="name" type="xs:string" use="required" />
            <xs:attribute name="path" type="xs:string" />
            <xs:attribute name="localCopy" type="xs:boolean" />
            <xs:attribute name="version" type="xs:string" />
          </xs:complexType>
        </xs:element>
        <xs:element ref="Files" />
      </xs:sequence>
      <xs:attribute name="name" type="xs:string" use="required" />
      <xs:attribute name="designerFolder" type="xs:string" default="" />
      <xs:attribute name="filterGroups" type="xs:string" default="" />
      <xs:attribute name="path" type="xs:string" default="" />
      <xs:attribute name="icon" type="xs:string" default="" />
      <xs:attribute name="configFile" type="xs:string" default="" />
      <xs:attribute name="version" type="xs:string" default="1.0.0" />
      <xs:attribute name="guid" type="xs:string"/>
      <xs:attribute name="language" default="C#">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="C#" />
            <xs:enumeration value="VB.NET" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="type" default="Exe">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="Exe" />
            <xs:enumeration value="WinExe" />
            <xs:enumeration value="Library" />
            <xs:enumeration value="Web" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="runtime" default="Microsoft">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="Microsoft" />
            <xs:enumeration value="Mono" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="frameworkVersion" default="v2_0">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="v2_0" />
            <xs:enumeration value="v3_0" />
            <xs:enumeration value="v3_5" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="startupObject" type="xs:string" default="" />
      <xs:attribute name="rootNamespace" type="xs:string" />
      <xs:attribute name="debugStartParameters" type="xs:string" />
      <xs:attribute name="assemblyName" type="xs:string" />
      <xs:attribute name="generateAssemblyInfoFile" type="xs:boolean" default="false" />
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Configuration">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="Options" minOccurs="0" />
      </xs:sequence>
      <xs:attribute name="name" type="xs:string" use="required" />
    </xs:complexType>
  </xs:element>
  <xs:element name="Options">
    <xs:complexType>
      <xs:all>
        <xs:element name="CompilerDefines" type="xs:string" minOccurs="0" />
        <xs:element name="OptimizeCode" type="xs:boolean" minOccurs="0" />
        <xs:element name="CheckUnderflowOverflow" type="xs:boolean" minOccurs="0" />
        <xs:element name="AllowUnsafe" type="xs:boolean" minOccurs="0" />
        <xs:element name="PreBuildEvent" type="xs:string" minOccurs="0" />
        <xs:element name="PostBuildEvent" type="xs:string" minOccurs="0" />
        <xs:element name="RunPostBuildEvent" minOccurs="0" default="OnBuildSuccess">
          <xs:simpleType>
            <xs:restriction base="xs:string">
              <xs:enumeration value="OnBuildSuccess" />
              <xs:enumeration value="Always" />
              <xs:enumeration value="OnOutputUpdated" />
            </xs:restriction>
          </xs:simpleType>
        </xs:element>
        <xs:element name="RunScript" type="xs:string" minOccurs="0" />
        <xs:element name="PreBuildEventArgs" type="xs:string" minOccurs="0" />
        <xs:element name="PostBuildEventArgs" type="xs:string" minOccurs="0" />
        <xs:element name="WarningLevel" minOccurs="0">
          <xs:simpleType>
            <xs:restriction base="xs:integer">
              <xs:minInclusive value="0" />
              <xs:maxInclusive value="4" />
            </xs:restriction>
          </xs:simpleType>
        </xs:element>
        <xs:element name="WarningsAsErrors" type="xs:boolean" minOccurs="0" />
        <xs:element name="SuppressWarnings" type="xs:string" minOccurs="0" />
        <xs:element name="OutputPath" type="xs:string" minOccurs="0" />
        <xs:element name="GenerateDocumentation" type="xs:boolean" minOccurs="0" />
        <xs:element name="XmlDocFile" type="xs:string" minOccurs="0" />
        <xs:element name="DebugInformation" type="xs:boolean" minOccurs="0" />
        <xs:element name="RegisterComInterop" type="xs:boolean" minOccurs="0" />
        <xs:element name="RemoveIntegerChecks" type="xs:boolean" minOccurs="0" />
        <xs:element name="IncrementalBuild" type="xs:boolean" minOccurs="0" />
        <xs:element name="BaseAddress" type="xs:string" minOccurs="0" />
        <xs:element name="FileAlignment" type="xs:integer" minOccurs="0" />
        <xs:element name="NoStdLib" type="xs:boolean" minOccurs="0" />
        <xs:element name="KeyFile" type="xs:string" minOccurs="0" />
      </xs:all>
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Files">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="File" minOccurs="0" maxOccurs="unbounded" />
        <xs:element ref="Match" minOccurs="0" maxOccurs="unbounded" />
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  
  <xs:element name="File">
    <xs:complexType>
      <xs:simpleContent>
        <xs:extension base="xs:string">
          <xs:attribute name="resourceName" type="xs:string" default="" />
          <xs:attribute name="buildAction" default="Compile">
            <xs:simpleType>
              <xs:restriction base="xs:string">
                <xs:enumeration value="None" />
                <xs:enumeration value="Compile" />
                <xs:enumeration value="Content" />
                <xs:enumeration value="EmbeddedResource" />
              </xs:restriction>
            </xs:simpleType>
          </xs:attribute>
          <xs:attribute name="subType" default="Code">
            <xs:simpleType>
              <xs:restriction base="xs:string">
                <xs:enumeration value="Code" />
                <xs:enumeration value="CodeBehind" />
                <xs:enumeration value="Component" />
                <xs:enumeration value="Form" />
                <xs:enumeration value="Settings" />
                <xs:enumeration value="UserControl" />
              </xs:restriction>
            </xs:simpleType>
          </xs:attribute>
          <xs:attribute name="link" type="xs:boolean" />
          <xs:attribute name="copyToOutput" default="Never">
            <xs:simpleType>
              <xs:restriction base="xs:string">
                <xs:enumeration value="Never" />
                <xs:enumeration value="Always" />
                <xs:enumeration value="PreserveNewest" />
              </xs:restriction>
            </xs:simpleType>
          </xs:attribute>
          <xs:attribute name="preservePath" type="xs:boolean" />
          <xs:attribute name="linkPath" type="xs:string" />
        </xs:extension>
      </xs:simpleContent>
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Match">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="Exclude" minOccurs="0" maxOccurs="unbounded" />
      </xs:sequence>
      <xs:attribute name="path" type="xs:string" />
      <xs:attribute name="pattern" type="xs:string" use="required" />
      <xs:attribute name="recurse" type="xs:boolean" default="false" />
      <xs:attribute name="useRegex" type="xs:boolean" default="false" />
      <xs:attribute name="buildAction" default="Compile">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="None" />
            <xs:enumeration value="Compile" />
            <xs:enumeration value="Content" />
            <xs:enumeration value="EmbeddedResource" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="resourceName" type="xs:string" default="" />
      <xs:attribute name="subType" default="Code">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="Code" />
            <xs:enumeration value="CodeBehind" />
            <xs:enumeration value="Component" />
            <xs:enumeration value="Designer" />
            <xs:enumeration value="Form" />
            <xs:enumeration value="Settings" />
            <xs:enumeration value="UserControl" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="link" type="xs:boolean" />
      <xs:attribute name="copyToOutput" default="Never">
        <xs:simpleType>
          <xs:restriction base="xs:string">
            <xs:enumeration value="Never" />
            <xs:enumeration value="Always" />
            <xs:enumeration value="PreserveNewest" />
          </xs:restriction>
        </xs:simpleType>
      </xs:attribute>
      <xs:attribute name="preservePath" type="xs:boolean" />
      <xs:attribute name="linkPath" type="xs:string" />
    </xs:complexType>
  </xs:element>
  
  <xs:element name="Exclude">
    <xs:complexType>
      <xs:attribute name="name" type="xs:string" />
      <xs:attribute name="pattern" type="xs:string" />
    </xs:complexType>
  </xs:element>

  <xs:element name="Cleanup">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="CleanFiles" minOccurs="1" maxOccurs="unbounded" />
      </xs:sequence>
    </xs:complexType>
  </xs:element>

  <xs:element name="CleanFiles">
    <xs:complexType>
      <xs:attribute name="pattern" type="xs:string" />
    </xs:complexType>
  </xs:element>
</xs:schema>
